import sys
import random
import argparse

def generate_test_file(noise_bits, number):

    p = random.randint(100, 1000)
    while p % 2 == 0:
        p = random.randint(100, 1000)

    max_noise = (1 << noise_bits) - 1  # 2^noise_bits - 1

    a = [str(p * random.randint(1, 100) + random.randint(0, max_noise)) for _ in range(number)]

    print(noise_bits)

    for b in a:
        print(b)

    print(f"// True p: {p}")

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description='Generate test input for AGCD computation')
    parser.add_argument('--noise-bits', type=int, default=5, help='Number of noise bits (default: 5)')
    parser.add_argument('--number', type=int, default=20, help='Number of numbers to generate (default: 20)')

    args = parser.parse_args()
    generate_test_file(args.noise_bits, args.number)
